<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref, computed, inject } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { useI18n } from 'vue-i18n';
import * as jose from 'jose'
import { request } from '@/lib/request';
import PasswordField from '@/components/general/form/PasswordField.vue';
import { setCookie } from '@/lib/utils';
import { useAccountStore } from '@/stores/account';
import { storeToRefs } from 'pinia';
import { useBaseStore } from '@/stores/base';
import { notificationStatus } from '@/enums/enums';
import Modal from '@/components/general/Modal.vue';


const route = useRoute();
const router = useRouter();
const baseStore = useBaseStore();
const { message, status } = storeToRefs(baseStore);
const store = useAccountStore();
const { mail: accountMail, accesscode, canUseAI } = storeToRefs(store);
const { t } = useI18n();
const $t = t;
document.title = $t('general.variables.account.sg') + ' ' + $t('general.variables.create');
const mail = ref('');
const mailDomain = computed(() => {
    return '@' + mail.value.split('@')[1];
})
const password = ref('');
const passwordConfirm = ref('');
const passwordValid = ref(true);
const passwordConfirmValid = ref(true);
let configuration = inject<any>('configuration');
const id = route.params.id;
const getRegistration = async () => {
    if (id) {
        let response = await request('GET', configuration.apiServer + '/api/registration/' + id);
        if (response && response.status) {
            mail.value = response.mail;
        } else {
            message.value = $t('general.errors.linkExpired');
            status.value = notificationStatus.DANGER;
            router.push({ name: "home" });
        }
    } else {
        message.value = $t('general.errors.linkExpired');
        status.value = notificationStatus.DANGER;
        router.push({ name: "home" });
    }
};

getRegistration();

const handleSubmit = async () => {
    showError.value = false;
    let response = await request('POST', configuration.apiServer + '/api/account/', { id, password: password.value, passwordConfirm: passwordConfirm.value, mailDomain: mailDomain.value, mailUsername: mail.value.split('@')[0] });
    if (response && response.success && response.token) {
        const payload = jose.UnsecuredJWT.decode(response.token);
        setCookie(response.token, configuration.basePath);
        accountMail.value = String(payload.payload.mail);
        accesscode.value = String(payload.payload.accesscode);
        canUseAI.value = Boolean(payload.payload.canUseAI);
        //document.cookie = "Token=" + response.token + ";" + "expires=" + new Date(Number(payload.payload.exp)).toUTCString() + ";path=/";
        router.push({ name: "overview-account" });
    } else {
        showError.value = true;
    }
};

const handleCancel = ()=>{
    router.push({ name: 'home'});
}

const showError = ref(false);
const valid = computed(()=>{
    return password.value && passwordConfirm.value && passwordValid.value && passwordConfirmValid.value && password.value === passwordConfirm.value;
});

</script>
<template>
<Modal :header="$t('general.variables.account.sg') + ' ' + $t('general.variables.create')" :disableSubmit="!Boolean(valid)" :labelSubmit="$t('general.buttons.save')" :labelCancel="$t('general.buttons.cancel')" @submit="handleSubmit" @cancel="handleCancel">
    <p class="text-red-700" v-if="showError">{{ $t('general.errors.unexpected') }}</p>
    <PasswordField v-model="password" v-model:valid="passwordValid" :strong="true"
        :error-text="$t('adminMenu.passwordReset.error.password.strong')"
        :label="$t('general.variables.password.sg')" />
    <PasswordField v-model="passwordConfirm" v-model:valid="passwordConfirmValid" :strong="true"
        :error-text="$t('adminMenu.passwordReset.error.password.strong')"
        :label="$t('general.variables.password.sg') + ' (' + $t('general.buttons.confirm') + ')'" />
</Modal>
</template>
<style scoped>
@media (min-width: 500px) {
    .container {
        max-width: 500px;
        min-width: 500px;
    }

}
</style>